/*
 * Exceptions.hpp
 *
 *  Created on: Mar 12, 2012
 *      Author: heber
 */

#ifndef EXCEPTIONS_HPP_
#define EXCEPTIONS_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <exception>
#include <boost/exception/all.hpp>

/** Base type for all exceptions regarding linear algebra.
 *
 */
struct ParserException : virtual std::exception, virtual boost::exception { };

/** ========================== General error information ================== */

/** Exception information for ParserException: non-present key of an internal map.
 */
typedef boost::error_info< struct tag_ParserMapLookup, const std::string > ParserMapLookup;

/** ============================ Specific exceptions ====================== */

/** Exception thrown when a lookup for an internal map fails.
 */
struct IllegalParserKeyException : virtual ParserException { };

#endif /* EXCEPTIONS_HPP_ */
