/*
 * TremoloParser_ElementKeys.hpp
 *
 *  Created on: Mar 12, 2012
 *      Author: heber
 */

#ifndef TREMOLOPARSER_ELEMENTKEYS_HPP_
#define TREMOLOPARSER_ELEMENTKEYS_HPP_


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iosfwd>
#include <map>
#include <string>

#include "Parser/Exceptions.hpp"

struct ElementKeys : private std::map<std::string, std::string>
{
  void parseKnownTypes(std::istream &file);
  void createKnownTypesByIdentity();

  const std::string &getType(const std::string &type) const throw (IllegalParserKeyException);
  void setType(const std::string &type, const std::string &value) throw (IllegalParserKeyException);
};


#endif /* TREMOLOPARSER_ELEMENTKEYS_HPP_ */
